<?php
namespace Geral\Repositories;

class Precoproposta extends \Doctrine\ORM\EntityRepository
{
    public static function getTabelaPrecos($cdPreco)
    {
        $sql = "SELECT NMPRECOPROP,DTINIPRECOPROP,DTFINPRECOPROP,
                       VRPRECOUNITSIST,VRPERCMANUTANO,NRMESPRAZOLOCA,
                       VRPEDESFILIFILI,VRPEDESFILIMATR
                  FROM PRECOPROPOSTA
                 WHERE CDPRECOPROP = :CDPRECOPROP";
        
        $params = array("CDPRECOPROP" => $cdPreco);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public static function getValorIndice()
    {
        $sql = "SELECT I.SGINDICE AS SGINDICE, I.NMINDICE, M.VRINDICE, 
                       TO_CHAR(M.DTREFIND,'MM/YYYY') AS DTREFIND
                  FROM MOVINDICE M, PAR_GERAL_FAS P, INDICE I
                 WHERE M.CDTPINDICE = P.CDTPINDICE
                   AND M.IDPERVALOR = P.IDPERVALOR
                   AND M.CDINDICE   = P.CDINDICE
                   AND I.CDTPINDICE = P.CDTPINDICE
                   AND I.IDPERVALOR = P.IDPERVALOR
                   AND I.CDINDICE   = P.CDINDICE
                   AND M.DTREFIND   = (SELECT MAX(DTREFIND)
                                       FROM MOVINDICE
                                      WHERE CDTPINDICE = P.CDTPINDICE
                                        AND IDPERVALOR = P.IDPERVALOR
                                        AND CDINDICE   = P.CDINDICE
                                        AND DTREFIND  <= LAST_DAY(TRUNC(SYSDATE)))";

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public static function tabelaPrecos($cdSegMer)
    {        
        $sql = "SELECT CDPRECOPROP, NMPRECOPROP
                  FROM (SELECT S.CDSEGMER, S.DSSEGMER, S.CDPRECOPROP, P.NMPRECOPROP, 'PRINCIPAL' IDPRINCIPAL
                          FROM SEGMERCADO S, PRECOPROPOSTA P
                         WHERE P.CDPRECOPROP = S.CDPRECOPROP
                         UNION ALL
                        SELECT PS.CDSEGMER, S.DSSEGMER, PS.CDPRECOPROP, P.NMPRECOPROP, NULL IDPRINCIPAL
                          FROM PRECOSEGMERCADO PS, SEGMERCADO S, PRECOPROPOSTA P
                         WHERE S.CDSEGMER = PS.CDSEGMER
                           AND P.CDPRECOPROP = PS.CDPRECOPROP)
                  WHERE CDSEGMER = :CDSEGMER";
        
        $params = array("CDSEGMER" => $cdSegMer);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
        
    }
}