const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geralPage = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const consistenciasFiscaisPage = require('../../../page-objects/parametrizacao/documentos fiscais/consistenciasFiscais.po.js');
const j = require('../../../json/leitorJson.po');
const consistenciasFiscaisGridId = '63521279131243893532319';

describe('Tela Consistências Fiscais', () => {
    beforeAll(() => {
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        consistenciasFiscaisPage.abrir();
        // geralPage.clickAplicarFiltro();
        geralPage.searchAndClickGridField('NMIMPOSTO', j.getValor('nmimposto00'));
        z.component.footer.clickRightActionByLabel('Filtrar', true);
        protractorHelper.waitForElementVisibility(element(by.id(`grid-${consistenciasFiscaisGridId}`)),
            5000);
    });

    afterAll(() => {
        geralPage.sair();
    });

    it('Acessar a tela Consistências Fiscais', () => {
        expect(z.component.header.getTitle()).toBe('Consistências Fiscais');
    });

    it('Pesquisar Consistência Fiscal por Sequêncial', () => {
        geralPage.filterIt(j.getValor('nrseqconsiste04'));
        expect(geralPage.gridHasText('63521279131243893532319', j.getValor('nrseqconsiste04'), 1)).toBe(j.getValor('nrseqconsiste04'));
    });

    xit('Inserir Alíquota Válida por CST e Imposto', () => {
        consistenciasFiscaisPage.inserirAliqValidaCstImposto(j.getValor('cdimposto50'), j.getValor('cdsitutribnfe03'), j.getValor('vraliquota03'));
        geralPage.filterIt(j.getValor('vraliquota03'));
        expect(geralPage.gridHasText('98674920340407954683218', j.getValor('vraliquota03'), 3)).toBe(j.getValor('vraliquota03'));
        geralPage.clickVoltar();
    });

    it('Excluir Alíqiuota por CST e Imposto', () => {
        consistenciasFiscaisPage.excluirAliqValidaCstImposto(j.getValor('cdimposto60'));
        geralPage.filterIt(j.getValor('cdsitutribnfe99'));
        geralPage.clickVoltar();
        expect(geralPage.gridHasText('98674920340407954683218', j.getValor('cdsitutribnfe99'), 3)).toBeUndefined(j.getValor('cdsitutribnfe99'));
    });

    it('Consulta CFOP', () => {
        geralPage.clickAcoes();
        geralPage.clickActionPorIndice(2);
        z.component.footer.clickRightActionByLabel('Filtrar');
        geralPage.filterIt(j.getValor('cdfiscoper'));
        expect(geralPage.gridHasText('144465170437366561683244', j.getValor('cdfiscoper'), 0)).toBe(j.getValor('cdfiscoper'));
        geralPage.clickVoltar();
    });
});
