const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geralPage = new Helper.geral();
const loginPage = new Helper.login();
const grupoFiscalPage = require('../../../page-objects/parametrizacao/documentos fiscais/grupoFiscal.po.js');
const j = require('../../../json/leitorJson.po');

describe('Tela Grupo Fiscal', () => {
    beforeEach(() => {
        browser.get('http://erpteste.teknisa.com/login/');
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        grupoFiscalPage.abrir();
        z.component.footer.clickRightActionByLabel('Filtrar', true);
    });

    afterEach(() => {
        z.component.menu.open();
        z.component.menu.clickByLabel('Sair');
        z.component.alert.clickButton('Sim');
    });

    it('Acessar a tela Grupo Fiscal', () => {
        expect(z.component.header.getTitle()).toBe('Grupo Fiscal');
    });

    it('Adicionar Grupo Fiscal 01', () => {
        grupoFiscalPage.adicionargrupoFiscal(j.getValor('cdgrupofiscal1'), j.getValor('dsgrupofiscal1'));
        geralPage.filterIt(j.getValor('dsgrupofiscal1'));
        expect(geralPage.gridHasText('3861781002721585151857', j.getValor('dsgrupofiscal1'), 1)).toBe(j.getValor('dsgrupofiscal1'));
    });

    it('Adicionar Grupo Fiscal 02', () => {
        grupoFiscalPage.adicionargrupoFiscal(j.getValor('cdgrupofiscal2'), j.getValor('dsgrupofiscal2'));
        geralPage.filterIt(j.getValor('dsgrupofiscal2'));
        expect(geralPage.gridHasText('3861781002721585151857', j.getValor('dsgrupofiscal2'), 1)).toBe(j.getValor('dsgrupofiscal2'));
    });

    it('Editar Grupo Fiscal 02', () => {
        geralPage.filterIt(j.getValor('dsgrupofiscal2'));
        geralPage.clickGrid('DSGRUPOFISC', j.getValor('dsgrupofiscal2'), '3861781002721585151857', false);
        grupoFiscalPage.editargrupoFiscal(j.getValor('dsgrupofiscal3'));
        expect(geralPage.gridHasText('3861781002721585151857', j.getValor('dsgrupofiscal3'), 1)).toBe(j.getValor('dsgrupofiscal3'));
    });

    it('Excluir Grupo Fiscal 01', () => {
        geralPage.filterIt(j.getValor('dsgrupofiscal1'));
        geralPage.clickGrid('DSGRUPOFISC', j.getValor('dsgrupofiscal1'), '3861781002721585151857', false);
        grupoFiscalPage.excluirgrupoFiscal();
        expect(geralPage.gridHasText('3861781002721585151857', j.getValor('dsgrupofiscal1'), false)).toBeUndefined();
    });
});
